program ncms_test
  use mpi
  use ISO_C_BINDING
  use petscmat
#include <petsc/finclude/petscmat.h>

  implicit none
  
  integer :: p_ierr,n,m,ierr,inode
  integer :: nl1,nl2,nlc1,nlc2,np
  real(C_DOUBLE) :: info(MAT_INFO_SIZE),nzratio
  character(256) :: stype,sdummy
  PetscRandom ::   rnd
  PetscReal :: norm
  PetscScalar :: p_scalar,p1,p2
  MatSolverType :: matsolvtype
  MatFactorInfo :: matfacinfo(MAT_FACTORINFO_SIZE)
  Mat :: A,B,C,F,D
  PetscViewer :: viewer


  matsolvtype=MATSOLVERELEMENTAL
  
  n=540
  m=n
  
  

  call PetscInitialize(PETSC_NULL_CHARACTER,p_ierr)

  call MPI_COMM_SIZE(PETSC_COMM_WORLD, np,ierr)
  call MPI_Comm_rank(PETSC_COMM_WORLD, inode, ierr )



  call MatCreateDense(PETSC_COMM_WORLD, PETSC_DECIDE, PETSC_DECIDE,n,m,PETSC_NULL_SCALAR,A,p_ierr)
  call MatCreateDense(PETSC_COMM_WORLD, PETSC_DECIDE, PETSC_DECIDE,n,m,PETSC_NULL_SCALAR,B,p_ierr)

  call PetscRandomCreate(PETSC_COMM_SELF,rnd,p_ierr)

  p1=1d0
  p2=2d0
  call PetscRandomSetInterval(rnd,p1,p2,p_ierr)
  call PetscRandomSetFromOptions(rnd,p_ierr);

  call MatSetRandom(A,rnd,p_ierr)
  call MatSetRandom(B,rnd,p_ierr)

  call MatConvert(A,MATELEMENTAL,MAT_INPLACE_MATRIX,A,p_ierr)
  call MatConvert(B,MATELEMENTAL,MAT_INPLACE_MATRIX,B,p_ierr) !working
  call MatConvert(B,MATMPIAIJ,MAT_INPLACE_MATRIX,B,p_ierr) !not working
  call MatAXPY(B,p_scalar,A,DIFFERENT_NONZERO_PATTERN,ierr)



  call petscfinalize(p_ierr)

end program ncms_test
